﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            // 서버 소켓이 동작하는 스레드
            Thread serverThread = new Thread(serverFunc);
            serverThread.IsBackground = true;
            serverThread.Start();

            Thread.Sleep(500); // 소켓 서버용 스레드가 실행될 시간을 주기 위해

            // 클라이언트 소켓이 동작하는 스레드
            Thread clientThread = new Thread(clientFunc);
            clientThread.IsBackground = true;
            clientThread.Start();

            Console.WriteLine("종료하려면 아무 키나 누르세요...");
            Console.ReadLine();
        }

        private static void serverFunc(object obj)
        {
            Socket socket =
                    new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            IPAddress ipAddress = GetCurrentIPAddress();
            if (ipAddress == null)
            {
                Console.WriteLine("IPv4 용 랜 카드가 없습니다.");
                return;
            }
            
            // 이 방법보다는 IPAddress.Any를 사용하는 것이 선호된다.
            //IPEndPoint endPoint = new IPEndPoint(ipAddress, 10200);

            IPEndPoint endPoint = new IPEndPoint(IPAddress.Any, 10200);

            socket.Bind(endPoint);
        }

        private static void clientFunc(object obj)
        {
            // ...... [클라이언트 소켓 코드 작성] ......
        }

        private static IPAddress GetCurrentIPAddress()
        {
            IPAddress[] addrs = Dns.GetHostEntry(Dns.GetHostName()).AddressList;

            foreach (IPAddress ipAddr in addrs)
            {
                if (ipAddr.AddressFamily == AddressFamily.InterNetwork)
                {
                    return ipAddr;
                }
            }

            return null;
        }
    }
}
